import greenfoot.*;  // (World, Actor, GreenfootImage, Greenfoot and MouseInfo)
public class Player extends Actor
{
    private int directionX = 0;
    private int directionY = 0;
    private int speed = 3;
    private int frame = 1;
    private int animationCounter = 0;
    private GreenfootImage redup1 = new GreenfootImage("redup1.png");// gambar untuk animasi jalan
    private GreenfootImage redup2 = new GreenfootImage("redup2.png");
    private GreenfootImage redup3 = new GreenfootImage("redup3.png");
    private GreenfootImage reddown1 = new GreenfootImage("reddown1.png");
    private GreenfootImage reddown2 = new GreenfootImage("reddown2.png");
    private GreenfootImage reddown3 = new GreenfootImage("reddown3.png");
    private GreenfootImage redright1 = new GreenfootImage("redright1.png");
    private GreenfootImage redright2 = new GreenfootImage("redright2.png");
    private GreenfootImage redright3 = new GreenfootImage("redright3.png");
    private GreenfootImage redleft3 = new GreenfootImage("redleft3.png");
    private GreenfootImage redleft2 = new GreenfootImage("redleft2.png");
    private GreenfootImage redleft1 = new GreenfootImage("redleft1.png");//gambar untuk animasi jalan
    public void act() 
    {
        checkKey(); //Memanggil method checkKey()
        goBattle(); //Memanggil method goBattle()
    }
    
        public void checkKey()
    {
        if(Greenfoot.isKeyDown("up"))
        {
            directionY = 1;
            moveUp();
        }
        if(Greenfoot.isKeyDown("down"))
        {
            directionY = -1;
            moveDown();
        }
        if(Greenfoot.isKeyDown("right"))
        {
            directionX = 1;
            moveRight();
        }
        if(Greenfoot.isKeyDown("left"))
        {
            directionX = -1;
            moveLeft();
        }
    }
    
    public void moveUp()
    {
        setLocation(getX(), getY()-speed);
        if(animationCounter % 3 == 0)
        {
            animateUp();
        }
        if(isTouching(batu.class))
        {
            setLocation(getX(), getY()+speed);
        }
    }
    
    public void animateUp()
    {
        if(frame == 1)
        {
            setImage(redup1);
        }
        else if(frame == 2)
        {
            setImage(redup2);
        }
        else if(frame == 3)
        {
            setImage(redup3);
            frame = 1;
            return;
        }
        frame++;
    }
    
    public void moveDown()
    {
        setLocation(getX(), getY()+speed);
        if(animationCounter % 3 == 0)
        {
            animateDown();
        }
        if(isTouching(batu.class))
        {
            setLocation(getX(), getY()-speed);
        }
    }
    
    public void animateDown()
    {
        if(frame == 1)
        {
            setImage(reddown1);
        }
        else if(frame == 2)
        {
            setImage(reddown2);
        }
        else if(frame == 3)
        {
            setImage(reddown3);
            frame = 1;
            return;
        }
        frame++;
    }
    
    public void moveRight()
    {
        setLocation(getX()+speed, getY());
        if(animationCounter % 3 == 0)
        {
            animateRight();
        }
        if(isTouching(batu.class))
        {
            setLocation(getX()-speed, getY());
        }
    }
    
    public void animateRight()
    {
        if(frame == 1)
        {
            setImage(redright1);
        }
        else if(frame == 2)
        {
            setImage(redright2);
        }
        else if(frame == 3)
        {
            setImage(redright3);
            frame = 1;
            return;
        }
        frame++;
    }
    
    public void moveLeft()
    {
        setLocation(getX()-speed, getY());
        if(animationCounter %3 == 0)
        {
            animateLeft();
        }
        if(isTouching(batu.class))
        {
            setLocation(getX()+speed, getY());
        }
    }
    
    public void animateLeft()
    {
        if(frame == 1)
        {
            setImage(redleft3);
        }
        else if(frame == 2)
        {
            setImage(redleft2);
        }
        else if(frame == 3)
        {
            setImage(redleft1);
            frame = 1;
            return;
        }
        frame++;
    }
    
    public void goBattle()
    {
        if(getOneIntersectingObject(Coba.class)!=null
        || getOneIntersectingObject(Brock.class)!=null)
        {
            ((Field)getWorld()).Music.stop();
            ((Field)getWorld()).removeObject(this);
            Greenfoot.setWorld(new Battle());
        }
    }
}